#############################################################
#
# prism2usb
#
#############################################################
prism2usb_VER:=0.2.2
prism2usb_SOURCE_URL:=ftp://ftp.linux-wlan.org/pub/linux-wlan-ng
prism2usb_SOURCE:=linux-wlan-ng-$(prism2usb_VER).tar.gz
prism2usb_BUILD_DIR:=$(BUILD_DIR)/linux-wlan-ng-$(prism2usb_VER)
#
# download source
#
$(DL_DIR)/$(prism2usb_SOURCE):
	 $(WGET) -P $(DL_DIR) $(prism2usb_SOURCE_URL)/$(prism2usb_SOURCE) 

#
# unpack source and potentially patch package; use bzcat for bz2 files
#
$(prism2usb_BUILD_DIR)/.unpacked: $(DL_DIR)/$(prism2usb_SOURCE)
	zcat $(DL_DIR)/$(prism2usb_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $@

#
# configure source, add additional options to configure as required
#
$(prism2usb_BUILD_DIR)/config.mk: $(prism2usb_BUILD_DIR)/.unpacked
	cd $(prism2usb_BUILD_DIR) ; \
	  cat config.in | sed -e 's/PRISM2_PCMCIA=y/PRISM2_PCMCIA=n/' \
            -e 's/PRISM2_USB=n/PRISM2_USB=y/' \
            -e "s+#LINUX_SRC=/usr/src/linux+LINUX_SRC=$(LINUX_DIR)+" \
            > config.in ; \
	  ./Configure -d
	# "Configure" devicename to eth 
	cd $(prism2usb_BUILD_DIR)/src/p80211 ; \
	  cat p80211netdev.c | sed -e 's/wlan%d/eth%d/' > p80211netdev.c

#
# build package
# 
$(prism2usb_BUILD_DIR)/src/prism2/driver/prism2_usb.o: $(prism2usb_BUILD_DIR)/config.mk
	cd $(prism2usb_BUILD_DIR) ; \
	        $(MAKE) KERNDIR=$(LINUX_DIR) \
		COPTS="$(TARGET_CONFIGURE_CFLAGS)" \
		CC=$(TARGET_CC)


#
# install package
#
$(TARGET_DIR)/lib/modules/$(LINUX_VERSION)/kernel/drivers/net/prism2usb.o: $(prism2usb_BUILD_DIR)/src/prism2/driver/prism2_usb.o
	cp $(prism2usb_BUILD_DIR)/src/prism2/driver/prism2_usb.o $(TARGET_DIR)/lib/modules/$(LINUX_VERSION)/kernel/drivers/net/prism2usb.o ; \
	cp $(prism2usb_BUILD_DIR)/src/p80211/p80211.o  $(TARGET_DIR)/lib/modules/$(LINUX_VERSION)/kernel/drivers/net/p80211.o


#
# to get prism2usb, we need $(TARGET_DIR)/usr/sbin/prism2usb
#   - to get $(TARGET_DIR)/usr/sbin/prism2usb, we need $(prism2usb_BUILD_DIR)/prism2usb
#      - before trying to build prism2usb, we need
#        $(prism2usb_BUILD_DIR)/.configured
#        ...
prism2usb: $(TARGET_DIR)/lib/modules/$(LINUX_VERSION)/kernel/drivers/net/prism2usb.o

prism2usb-source: $(DL_DIR)/$(prism2usb_SOURCE)

prism2usb-clean:
	-$(MAKE) -C $(prism2usb_BUILD_DIR) KERNELPATH=$(LINUX_DIR) clean

prism2usb-dirclean:
	rm -rf $(prism2usb_BUILD_DIR)
